package redis

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

const (
	ADDR           string = "192.168.1.229:6379"
	ADDR_protected string = "192.168.1.201:6379"
)

func TestRedisMatcher(t *testing.T) {

	m := NewMatcher()

	conn, _ := net.Dial("tcp", ADDR)
	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {
		_, err := conn.Write(m.Packet(i).Buffer)
		if err != nil {
			t.Error(err)
		}
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := osm.NewPacket(bytes, n)

		if err := m.Match(nil, i, p); err != nil {
			t.Error(err)
			return
		}
	}
	t.Log(m.Name())
	t.Log(m.Meta())

}
