package smb

import (
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

const (
	ADDR string = "192.168.1.101:445"
)

func TestSMBMatcher(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("tcp", ADDR)

	if err != nil {
		t.Fatal(err)
	}

	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {

		pack := m.Packet(i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)

		p := osm.NewPacket(bytes, n)

		if err := m.Match(nil, 0, p); err != nil {
			t.Error(err)
		}
	}
	t.Log(m.Name())
	t.Log(m.Meta())
}
